import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import "core-js/modules/es6.regexp.to-string";
import "core-js/modules/es6.object.to-string";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import * as React from 'react';
import './index.css';
import AvatarImg from '../../../../../components/common/avatarImg';
import { jumpPerson } from '../../../../../helper/jumpToPersonHome';
import ScrollWrap from '../../../../../components/common/scrollWrap';
import { getApiUrl, taker, getUserInfo, goReward } from '../../../../../helper';
import ToolTip from '@beisen/tool-tip';

var SelfOrder =
/*#__PURE__*/
function (_React$Component) {
  _inherits(SelfOrder, _React$Component);

  function SelfOrder() {
    _classCallCheck(this, SelfOrder);

    return _possibleConstructorReturn(this, _getPrototypeOf(SelfOrder).apply(this, arguments));
  }

  _createClass(SelfOrder, [{
    key: "render",
    value: function render() {
      var data = this.props.data;
      return React.createElement("div", {
        className: 'bound-self-order'
      }, React.createElement("span", {
        className: 'self-head',
        onClick: function onClick() {
          jumpPerson(data.User.UserId, 1);
        }
      }, React.createElement(AvatarImg, {
        size: 20,
        color: data.User.Avatar.Color,
        src: data.User.Avatar.Small,
        name: data.User.Name
      })), React.createElement("span", {
        className: 'bound-self-order-describe'
      }, React.createElement("span", null, "\u6211\u7B2C"), React.createElement("span", {
        className: 'postion-num'
      }, data.Position), React.createElement("span", null, "\u540D")), React.createElement("span", {
        className: 'agree-time'
      }, React.createElement("span", null, "\u83B7\u8D4F"), React.createElement("span", {
        className: 'reward-count'
      }, data.RankBasis), React.createElement("span", null, "\u6B21")));
    }
  }]);

  return SelfOrder;
}(React.Component);

var HaveDataView =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(HaveDataView, _React$Component2);

  function HaveDataView(p) {
    var _this;

    _classCallCheck(this, HaveDataView);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(HaveDataView).call(this, p));

    _this.agree = function (e, uid, key) {
      e.stopPropagation();
      if (_this.isfetching) return;
      _this.isfetching = true;
      var _this$props = _this.props,
          datas = _this$props.datas,
          fanwei = _this$props.fanwei; // const { agree0, agree1, agree2 } = this.state;

      var thumbUped = _this.state["agree".concat(key)];

      var data = datas[key]; //uid 点赞取消赞接口－－加限制

      var urlStr = '';

      if (thumbUped) {
        //取消赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/CancelLike';
      } else {
        //点赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/Like';
      }

      var url = getApiUrl(urlStr);
      var mapDianZan = [0, 1, 1, 2, 3, 4];

      if (data) {
        taker(url, 'POST', {
          "appObj": {
            "AppObjId": data.User.UserId,
            "AppObjType": 9501005,
            "PeriodType": mapDianZan[fanwei],
            "ReceiverId": data.User.UserId
          }
        }).then(function (res) {
          _this.timeOut && clearTimeout(_this.timeOut);
          _this.timeOut = setTimeout(function () {
            _this.isfetching = false;
          }, 300);

          if (res.Code == 200) {
            //点赞｜取消赞结束，改状态。
            _this.state["agree".concat(key)] = !thumbUped;

            _this.forceUpdate();
          }
        });
      }
    };

    _this.getWidth = function (pos) {
      var tempLen = pos.toString().length;
      return 38 + tempLen * 7 + 'px';
    };

    _this.fillData = function (datas, len) {
      var tempArr = _toConsumableArray(datas);

      for (var index = 0; index < len; index++) {
        tempArr.push(undefined);
      }

      return tempArr;
    };

    var datas = p.datas;
    _this.state = {
      agree0: datas[0] ? !datas[0].CanThumbUp : false,
      agree1: datas[1] ? !datas[1].CanThumbUp : false,
      agree2: datas[2] ? !datas[2].CanThumbUp : false
    };
    return _this;
  }

  _createClass(HaveDataView, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(np) {
      var datas = np.datas;
      var state = {
        agree0: datas[0] ? !datas[0].CanThumbUp : false,
        agree1: datas[1] ? !datas[1].CanThumbUp : false,
        agree2: datas[2] ? !datas[2].CanThumbUp : false
      };
      this.setState(state);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var datas = this.props.datas;
      var positionClass = ['middle', 'left', 'right'];
      var aimLen = 3 - datas.length;
      var tempDatas = aimLen <= 0 ? datas.slice(0, 3) : this.fillData(datas, aimLen);
      return React.createElement("div", {
        className: 'have-data-view'
      }, tempDatas.map(function (data, k) {
        var isSelf = false;

        if (data) {
          var userInfo = getUserInfo();
          isSelf = data.User.UserId == userInfo.Id;
        }

        return data ? React.createElement("span", {
          className: positionClass[k],
          key: "item-data".concat(k),
          onClick: function onClick() {
            jumpPerson(data.User.UserId, 1);
          }
        }, React.createElement("div", {
          className: "hover-show-agree"
        }, React.createElement(AvatarImg, {
          name: data.User.Name,
          src: data.User.Avatar.Medium,
          size: k == 0 ? 50 : 40,
          color: data.User.Avatar.Color
        }), React.createElement(ToolTip, {
          slide: false,
          title: data.User.Name
        }, React.createElement("span", {
          className: "name ".concat(k == 0 ? 'is-self' : '')
        }, data.User.Name)), React.createElement("div", {
          style: {
            display: isSelf ? 'none' : ''
          },
          className: _this2.state["agree".concat(k)] ? 'agree-icon font-agree' : 'agree-icon font-agree-border',
          onClick: function onClick(e) {
            _this2.agree(e, data.User.UserId, k);
          }
        })), React.createElement("div", {
          className: 'describe',
          style: {
            width: '58px',
            left: '-7px',
            textAlign: 'center',
            whiteSpace: 'nowrap'
          }
        }, data.RankBasis)) : React.createElement("span", {
          key: "item-data".concat(k),
          className: "no-data ".concat(positionClass[k])
        }, " ");
      }));
    }
  }]);

  return HaveDataView;
}(React.Component);

var NoDataView =
/*#__PURE__*/
function (_React$Component3) {
  _inherits(NoDataView, _React$Component3);

  function NoDataView() {
    _classCallCheck(this, NoDataView);

    return _possibleConstructorReturn(this, _getPrototypeOf(NoDataView).apply(this, arguments));
  }

  _createClass(NoDataView, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        className: 'no-data-view-order'
      }, React.createElement("span", {
        className: 'left'
      }, " "), React.createElement("span", {
        className: 'middle'
      }, " "), React.createElement("span", {
        className: 'right'
      }, " "));
    }
  }]);

  return NoDataView;
}(React.Component);

var OrderBody =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(OrderBody, _React$PureComponent);

  function OrderBody(p) {
    var _this3;

    _classCallCheck(this, OrderBody);

    _this3 = _possibleConstructorReturn(this, _getPrototypeOf(OrderBody).call(this, p));

    _this3.genfriendlyTips = function () {
      return React.createElement("div", {
        className: "encourage-language"
      }, "\u4F60\u8FD8\u6CA1\u6709\u4E0A\u699C\u54E6\uFF0C\u8981\u7EE7\u7EED\u52A0\u6CB9\uFF01");
    };

    _this3.udc = encodeURIComponent(JSON.stringify({
      ext: {
        type: "reward",
        desc: "entry",
        from: "c-reward-news"
      }
    }));
    return _this3;
  }

  _createClass(OrderBody, [{
    key: "componentDidMount",
    value: function componentDidMount() {// loadRewardPop()
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          data = _this$props2.data,
          datas = _this$props2.datas,
          fanwei = _this$props2.fanwei,
          isSelf = _this$props2.isSelf;
      var userInfo = getUserInfo();
      return React.createElement(ScrollWrap, {
        height: '100%'
      }, React.createElement("div", {
        className: 'bound-order-body-wraps'
      }, React.createElement("div", {
        className: 'order-three-contain'
      }, datas && datas.length ? React.createElement(HaveDataView, {
        datas: datas,
        fanwei: fanwei,
        selfId: data ? data.User.UserId : userInfo.Id
      }) : React.createElement("div", {
        className: 'no-data-wrap'
      }, React.createElement("div", {
        className: 'cover'
      }), React.createElement(NoDataView, null))), datas.length > 0 && data ? data && data.RankBasis < 0 ? isSelf && this.genfriendlyTips() : isSelf && React.createElement(SelfOrder, {
        data: data
      }) : isSelf && React.createElement("div", {
        className: "go-reward-in-reward-order"
      }, React.createElement("div", {
        className: "go-reward-in-reward-order-language"
      }, "\u6392\u884C\u699C\u865A\u4F4D\u4EE5\u5F85\uFF0C\u8C01\u662F\u4F60\u5FC3\u4E2D\u6700\u68D2\u7684ta ?"), React.createElement("div", {
        className: 'go-reward-in-reward-order-a',
        onClick: goReward,
        "data-udc": this.udc
      }, "\u53BB\u6253\u8D4F"))));
    }
  }]);

  return OrderBody;
}(React.PureComponent);

export { OrderBody as default };